
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Python多进程教程 / iVAN</title>

    <meta name="description" content="Python多进程教程 Python2.6版本中新添了multiprocessing模块.它最初由Jesse Noller和Richard Oudkerk定义在PEP 371中.就像你能通过threading模块衍生线程一样,multiprocessing 模块允许你衍生进程.这里用到的思想:因为你现在能衍生进程,所以你能够避免使用全局解释器锁(GIL),并且充分利用机器的多个处理器. 多进程包也包含一些根本不在threading 模块中的API.比如:有一个灵活的Pool类能让你在多个输入下并行化地执行函数.我们将在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Python多进程教程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczUuNTFjdG8uY29tL3d5ZnMwMi9NMDIvOUEvNkIvd0tpb20xbFZ0WFR5aEF5WkFBQWw5QS14QnRvOTI5LmpwZy13aF82NTF4LXNfOTY1NDU0MTU5LmpwZw==.jpg"></p>
<p>Python2.6版本中新添了multiprocessing模块。它最初由Jesse Noller和Richard<br />
Oudkerk定义在PEP  371中。就像你能通过threading模块衍生线程一样，multiprocessing<br />
模块允许你衍生进程。这里用到的思想：因为你现在能衍生进程，所以你能够避免使用全局解释器锁(GIL)，并且充分利用机器的多个处理器。</p>
<p>多进程包也包含一些根本不在threading  模块中的API。比如：有一个灵活的Pool类能让你在多个输入下并行化地执行函数。我们将在后面的小节讲解Pool类。我们将以multiprocessing模块的Process类开始讲解。</p>
<p><strong>开始学习multiprocessing模块</strong></p>
<p>Process这个类和threading模块中的Thread类很像。让我们创建一系列调用相同函数的进程，并且看看它是如何工作的。</p>
<pre>
</pre>
<ol>
<li>import os </li>
<li> </li>
<li>from multiprocessing import Process </li>
<li> </li>
<li>def doubler(number): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    A doubling function that can be used by a process </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    result = number * 2 </li>
<li> </li>
<li>    proc = os.getpid() </li>
<li> </li>
<li>    print('{0} doubled to {1} by process id: {2}'.format( </li>
<li> </li>
<li>        number, result, proc)) </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    numbers = [5, 10, 15, 20, 25] </li>
<li> </li>
<li>    procs = [] </li>
<li> </li>
<li>    for index, number in enumerate(numbers): </li>
<li> </li>
<li>        proc = Process(target=doubler, args=(number,)) </li>
<li> </li>
<li>        procs.append(proc) </li>
<li> </li>
<li>        proc.start() </li>
<li> </li>
<li>    for proc in procs: </li>
<li> </li>
<li>        proc.join() </li>
</ol>
<p>对于上面的例子，我们导入Process类、创建一个叫doubler的函数。在函数中，我们将传入的数字乘上2。我们也用Python的os模块来获取当前进程的ID(pid)。这个ID将告诉我们哪个进程正在调用doubler函数。然后，在下面的代码块中，我们实例化了一系列的Process类并且启动它们。最后一个循环只是调用每个进程的join()方法，该方法告诉Python等待进程直到它结束。如果你需要结束一个进程，你可以调用它的terminate()方法。</p>
<p>当你运行上面的代码，你应该看到和下面类似的输出结果：</p>
<pre>
</pre>
<ol>
<li>5 doubled to 10 by process id: 10468 </li>
<li> </li>
<li>10 doubled to 20 by process id: 10469 </li>
<li> </li>
<li>15 doubled to 30 by process id: 10470 </li>
<li> </li>
<li>20 doubled to 40 by process id: 10471 </li>
<li> </li>
<li>25 doubled to 50 by process id: 10472 </li>
</ol>
<p>有时候，你最好给你的进程取一个易于理解的名字 。幸运的是，Process类确实允许你访问同样的进程。让我们来看看如下例子：</p>
<pre>
</pre>
<ol>
<li>import os </li>
<li> </li>
<li>from multiprocessing import Process, current_process </li>
<li> </li>
<li>def doubler(number): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    A doubling function that can be used by a process </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    result = number * 2 </li>
<li> </li>
<li>    proc_name = current_process().name </li>
<li> </li>
<li>    print('{0} doubled to {1} by: {2}'.format( </li>
<li> </li>
<li>        number, result, proc_name)) </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    numbers = [5, 10, 15, 20, 25] </li>
<li> </li>
<li>    procs = [] </li>
<li> </li>
<li>    proc = Process(target=doubler, args=(5,)) </li>
<li> </li>
<li>    for index, number in enumerate(numbers): </li>
<li> </li>
<li>        proc = Process(target=doubler, args=(number,)) </li>
<li> </li>
<li>        procs.append(proc) </li>
<li> </li>
<li>        proc.start() </li>
<li> </li>
<li>    proc = Process(target=doubler, name='Test', args=(2,)) </li>
<li> </li>
<li>    proc.start() </li>
<li> </li>
<li>    procs.append(proc) </li>
<li> </li>
<li>    for proc in procs: </li>
<li> </li>
<li>        proc.join() </li>
</ol>
<p>这一次，我们多导入了current_process。current_process基本上和threading模块的current_thread是类似的东西。我们用它来获取正在调用我们的函数的线程的名字。你将注意到我们没有给前面的5个进程设置名字。然后我们将第6个进程的名字设置为“Test”。</p>
<p>让我们看看我们将得到什么样的输出结果：</p>
<pre>
</pre>
<ol>
<li>5 doubled to 10 by: Process-2 </li>
<li> </li>
<li>10 doubled to 20 by: Process-3 </li>
<li> </li>
<li>15 doubled to 30 by: Process-4 </li>
<li> </li>
<li>20 doubled to 40 by: Process-5 </li>
<li> </li>
<li>25 doubled to 50 by: Process-6 </li>
<li> </li>
<li>2 doubled to 4 by: Test </li>
</ol>
<p>输出结果说明：默认情况下，multiprocessing模块给每个进程分配了一个编号，而该编号被用来组成进程的名字的一部分。当然，如果我们给定了名字的话，并不会有编号被添加到名字中。</p>
<p><strong>锁</strong></p>
<p>multiprocessing模块支持锁，它和threading模块做的方式一样。你需要做的只是导入Lock，获取它，做一些事，释放它。</p>
<pre>
</pre>
<ol>
<li>from multiprocessing import Process, Lock </li>
<li> </li>
<li>def printer(item, lock): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    Prints out the item that was passed in </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    lock.acquire() </li>
<li> </li>
<li>    try: </li>
<li> </li>
<li>        print(item) </li>
<li> </li>
<li>    finally: </li>
<li> </li>
<li>        lock.release() </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    lock = Lock() </li>
<li> </li>
<li>    items = ['tango', 'foxtrot', 10] </li>
<li> </li>
<li>    for item in items: </li>
<li> </li>
<li>        p = Process(target=printer, args=(item, lock)) </li>
<li> </li>
<li>        p.start() </li>
</ol>
<p>我们在这里创建了一个简单的用于打印函数，你输入什么，它就输出什么。为了避免线程之间互相阻塞，我们使用Lock对象。代码循环列表中的三个项并为它们各自都创建一个进程。每一个进程都将调用我们的函数，并且每次遍历到的那一项作为参数传入函数。因为我们现在使用了锁，所以队列中下一个进程将一直阻塞，直到之前的进程释放锁。</p>
<p><strong>日志</strong></p>
<p>为进程创建日志与为线程创建日志有一些不同。它们存在不同是因为Python的logging包不使用共享锁的进程，因此有可能以来自不同进程的信息作为结束的标志。让我们试着给前面的例子添加基本的日志。代码如下：</p>
<pre>
</pre>
<ol>
<li>import logging </li>
<li> </li>
<li>import multiprocessing </li>
<li> </li>
<li>from multiprocessing import Process, Lock </li>
<li> </li>
<li>def printer(item, lock): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    Prints out the item that was passed in </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    lock.acquire() </li>
<li> </li>
<li>    try: </li>
<li> </li>
<li>        print(item) </li>
<li> </li>
<li>    finally: </li>
<li> </li>
<li>        lock.release() </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    lock = Lock() </li>
<li> </li>
<li>    items = ['tango', 'foxtrot', 10] </li>
<li> </li>
<li>    multiprocessing.log_to_stderr() </li>
<li> </li>
<li>    logger = multiprocessing.get_logger() </li>
<li> </li>
<li>    logger.setLevel(logging.INFO) </li>
<li> </li>
<li>    for item in items: </li>
<li> </li>
<li>        p = Process(target=printer, args=(item, lock)) </li>
<li> </li>
<li>        p.start() </li>
</ol>
<p>最简单的添加日志的方法通过推送它到stderr实现。我们能通过调用thelog_to_stderr()<br />
函数来实现该方法。然后我们调用get_logger<br />
函数获得一个logger实例，并将它的日志等级设为INFO。之后的代码是相同的。需要提示下这里我并没有调用join()方法。取而代之的：当它退出，父线程将自动调用join()方法。</p>
<p>当你这么做了，你应该得到类似下面的输出：</p>
<pre>
</pre>
<ol>
<li>[INFO/Process-1] child process calling self.run() </li>
<li> </li>
<li>tango </li>
<li> </li>
<li>[INFO/Process-1] process shutting down </li>
<li> </li>
<li>[INFO/Process-1] process exiting with exitcode 0 </li>
<li> </li>
<li>[INFO/Process-2] child process calling self.run() </li>
<li> </li>
<li>[INFO/MainProcess] process shutting down </li>
<li> </li>
<li>foxtrot </li>
<li> </li>
<li>[INFO/Process-2] process shutting down </li>
<li> </li>
<li>[INFO/Process-3] child process calling self.run() </li>
<li> </li>
<li>[INFO/Process-2] process exiting with exitcode 0 </li>
<li> </li>
<li>10 </li>
<li> </li>
<li>[INFO/MainProcess] calling join() for process Process-3 </li>
<li> </li>
<li>[INFO/Process-3] process shutting down </li>
<li> </li>
<li>[INFO/Process-3] process exiting with exitcode 0 </li>
<li> </li>
<li>[INFO/MainProcess] calling join() for process Process-2 </li>
</ol>
<p>现在如果你想要保存日志到硬盘中，那么这件事就显得有些棘手。你能在Python的logging Cookbook阅读一些有关那类话题。</p>
<p><strong>Pool类</strong></p>
<p>Pool类被用来代表一个工作进程池。它有让你将任务转移到工作进程的方法。让我们看下面一个非常简单的例子。</p>
<pre>
</pre>
<ol>
<li>from multiprocessing import Pool </li>
<li> </li>
<li>def doubler(number): </li>
<li> </li>
<li>    return number * 2 </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    numbers = [5, 10, 20] </li>
<li> </li>
<li>    pool = Pool(processes=3) </li>
<li> </li>
<li>    print(pool.map(doubler, numbers)) </li>
</ol>
<p>基本上执行上述代码之后，一个Pool的实例被创建，并且该实例创建了3个工作进程。然后我们使用map  方法将一个函数和一个可迭代对象映射到每个进程。最后我们打印出这个例子的结果：[10, 20, 40]。</p>
<p>你也能通过apply_async方法获得池中进程的运行结果：</p>
<pre>
</pre>
<ol>
<li>from multiprocessing import Pool </li>
<li> </li>
<li>def doubler(number): </li>
<li> </li>
<li>    return number * 2 </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    pool = Pool(processes=3) </li>
<li> </li>
<li>    result = pool.apply_async(doubler, (25,)) </li>
<li> </li>
<li>    print(result.get(timeout=1)) </li>
</ol>
<p>我们上面做的事实际上就是请求进程的运行结果。那就是get函数的用途。它尝试去获取我们的结果。你能够注意到我们设置了timeout，这是为了预防我们调用的函数发生异常的情况。毕竟我们不想要它被无限期地阻塞。</p>
<p><strong>进程通信</strong></p>
<p>当遇到进程间通信的情况，multiprocessing 模块提供了两个主要的方法：Queues 和 Pipes。Queue<br />
实现上既是线程安全的也是进程安全的。让我们看一个相当简单的并且基于 Queue的例子。代码来自于我的文章(threading<br />
articles)。</p>
<pre>
</pre>
<ol>
<li>from multiprocessing import Process, Queue </li>
<li> </li>
<li>sentinel = -1 </li>
<li> </li>
<li>def creator(data, q): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    Creates data to be consumed and waits for the consumer </li>
<li> </li>
<li>    to finish processing </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    print('Creating data and putting it on the queue') </li>
<li> </li>
<li>    for item in data: </li>
<li> </li>
<li>        q.put(item) </li>
<li> </li>
<li>def my_consumer(q): </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    Consumes some data and works on it </li>
<li> </li>
<li>    In this case, all it does is double the input </li>
<li> </li>
<li>    """ </li>
<li> </li>
<li>    while True: </li>
<li> </li>
<li>        data = q.get() </li>
<li> </li>
<li>        print('data found to be processed: {}'.format(data)) </li>
<li> </li>
<li>        processed = data * 2 </li>
<li> </li>
<li>        print(processed) </li>
<li> </li>
<li>        if data is sentinel: </li>
<li> </li>
<li>            break </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li> </li>
<li>    q = Queue() </li>
<li> </li>
<li>    data = [5, 10, 13, -1] </li>
<li> </li>
<li>    process_one = Process(target=creator, args=(data, q)) </li>
<li> </li>
<li>    process_two = Process(target=my_consumer, args=(q,)) </li>
<li> </li>
<li>    process_one.start() </li>
<li> </li>
<li>    process_two.start() </li>
<li> </li>
<li>    q.close() </li>
<li> </li>
<li>    q.join_thread() </li>
<li> </li>
<li>    process_one.join() </li>
<li> </li>
<li>    process_two.join() </li>
</ol>
<p>在这里我们只需要导入Queue和Process。Queue用来创建数据和添加数据到队列中，Process用来消耗数据并执行它。通过使用Queue的put()和get()方法，我们就能添加数据到Queue、从Queue获取数据。代码的最后一块只是创建了Queue<br />
  对象以及两个Process对象，并且运行它们。你能注意到我们在进程对象上调用join()方法，而不是在Queue本身上调用。</p>
<p><strong>总结</strong></p>
<p>我们这里有大量的资料。你已经学习如何使用multiprocessing模块指定不变的函数、使用Queues在进程间通信、给进程命名等很多事。在Python文档中也有很多本文没有接触到的知识点，因此也务必深入了解下文档。与此同时，你现在知道如何用Python利用你电脑所有的处理能力了!</p>
<p>作者：佚名</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 21:53:20</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e6%97%a5%e5%bf%97/" title="日志">日志</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e8%bf%9b%e7%a8%8b/" title="多进程">多进程</a>, <a href="https://www.iamivan.net/tag/lock/" title="lock">lock</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Python多进程教程的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP8Dklp.html" rel="bookmark">Python快速教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:Python快速教程 作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.谢谢!   怎么能快速地掌握Python?这是和朋友闲聊时谈起的问题. Python包含的内容很多,加上各种标准库,拓展库,乱花渐欲迷人眼.一直希望写一个快速的.容易上手的Python教程.目标是做到言语简洁,循序渐进,让没有背景的读者也可以从基础开始学习.我在每一篇中专注于一个小的概念,希望在闲暇时可以很快读完. 小提醒 教程将专注于Python基础,语法基			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqW9kz.html" rel="bookmark">Python快速教程 尾声</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  写了将近两年的Python快速教程,终于大概成形.这一系列文章,包括Python基础.标准库.Django框架.前前后后的文章,包含了Python最重要的组成部分.这一内容的跨度远远超过我的预期,也超过了我看过的任何Python相关书籍.最初动笔的原因,除了要总结,还对很多Python书和教程觉得不满意,觉得太晦涩,又不够全面.现在,我比较确定,参考我在Linux.网络.算法方面的总结,读者可以在无基础的背景下,在短时间,有深度的学习Python了. 这一篇也是尾声.准备在一个长的时间内,停			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAadk2M.html" rel="bookmark">Python多进程机制实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了Python多进程机制.分享给大家供大家参考.具体如下: 在以前只是接触过PYTHON的多线程机制,今天搜了一下多进程,相关文章好像不是特别多.看了几篇,小试了一把.程序如下,主要内容就是通过PRODUCER读一个本地文件,一行一行的放到队列中去.然后会有相应的WORKER从队列中取出这些行. ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 3			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKdPVp.html" rel="bookmark">Python多进程并发&lpar;multiprocessing&rpar;用法实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了Python多进程并发(multiprocessing)用法.分享给大家供大家参考.具体分析如下: 由于Python设计的限制(我说的是咱们常用的CPython).最多只能用满1个CPU核心. Python提供了非常好用的多进程包multiprocessing,你只需要定义一个函数,Python会替你完成其他所有事情.借助这个包,可以轻松完成从单进程到并发执行的转换. 1.新建单一进程 如果我们新建少量进程,可以如下: ? 1 2 3 4 5 6 7 8 9 10 11 imp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvKkZVp.html" rel="bookmark">Python多进程编程下线程之间变量的共享问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了探究Python多进程编程下线程之间变量的共享问题,多进程编程是Python学习进阶中的重要知识,需要的朋友可以参考下 1.问题: 群中有同学贴了如下一段代码,问为何 list 最后打印的是空值? ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 from multiprocessing import Process, Manager import os   manage			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWXk1Gp.html" rel="bookmark">Shell和Python学习教程总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				博友们好,由于运维相关技术不断发展,个人能力也不断提高,渐渐积累的经验不能及时更新到以往的博文中.因此,为了更好的帮助大家学习运维技术,特地针对Shell和Python脚本语言总结了文档,此文档会不定期修改或增加知识点,为了能让你及时下载最新的文档,请点击GitHub收藏或请加QQ技术群:323779636(Shell/Python运维开发群),里面有更多的学习资料和定期的分享课,希望我们能一起学习,一起进步,一起走上人生巅峰!哈哈~ &lt;&lt;Shell从入门到精通&gt;&gt;和&lt;&lt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwLwlnb.html" rel="bookmark">第十五章  Python多进程与多线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				15.1 multiprocessing multiprocessing是多进程模块,多进程提供了任务并发性,能充分利用多核处理器.避免了GIL(全局解释锁)对资源的影响. 有以下常用类: 类 描述 Process(group=None, target=None, name=None, args=(), kwargs={}) 派生一个进程对象,然后调用start()方法启动 Pool(processes=None, initializer=None, initargs=()) 返回一个进程池对象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqA7yGM.html" rel="bookmark">Python多进程multiprocessing使用示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				来源:http://outofmemory.cn/code-snippet/2267/Python-duojincheng-multiprocessing-usage-example 来源:http://www.jb51.net/article/67116.htm 来源:http://blog.csdn.net/qdx411324962/article/details/46810421 来源:http://www.lxway.com/4488626156.htm 由于要做把一个多线程改成多进程,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmX95b.html" rel="bookmark">Python多进程编程技术实例分析&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文以实例形式分析了Python多进程编程技术,有助于进一步Python程序设计技巧.分享给大家供大家参考.具体分析如下: 一般来说,由于Python的线程有些限制,例如多线程不能充分利用多核CPU等问题,因此在Python中我们更倾向使用多进程.但在做不阻塞的异步UI等场景,我们也会使用多线程.本篇文章主要探讨Python多进程的问题. Python在2.6引入了多进程的机制,并提供了丰富的组件及api以方便编写并发应用.multiprocessing包的组件Process, Queue, P			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGwXvz.html" rel="bookmark" class="title">10个详细的CSS3表单制作教程</a>
					<div>
						CSS3在国外应用已经很广泛了,所以我们也应该尽快学会使用CSS3,下面有10个CSS3的教程,非常详细,而且配合jQuery使用,使得用户体验增强不少,做为前端的你,应该抽点时间看看,百利而无一害. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zG8Deb.html" rel="bookmark" class="title">如何让网站关键词带来流量？</a>
					<div>
						一个网站如果想要有跟多的流量那么你们网站的关键词就要选择的好如果 你们选择的关键词能给你带来超高的人气那就很厉害了一个好的关键如果有好 的排名,那个给你网站带来的流量也是非常高的,所以说选择关键词也是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL24vb.html" rel="bookmark" class="title">php高效获取数据分页</a>
					<div>
						mysql.php 获取数据库中的记录,完全个人经验总结,仅供参考! &lt;?php /** *PHP+MYSQL数据库基本功能 *http://blog.csdn.net/yown */ #### ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNqg4b.html" rel="bookmark" class="title">用来检查颜色值的正则表达式</a>
					<div>
						正则 &lt;input type=&quot;text&quot; name=&quot;color&quot;&gt;&lt;input type=&quot;button&quot; value ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlZX8z.html" rel="bookmark" class="title">Java中文问题详解&lpar;高手必读）</a>
					<div>
						问题|详解|中文 我来说一下tomcat如何实现JSP的你就明白了.预备知识: 1.字节和unicode Java内核是unicode的,就连class文件也是,但是很多媒体,包括文件/流的保存方式  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwOYmz.html" rel="bookmark" class="title">另一种bbs设计的思路，请各位高手给予评价。</a>
					<div>
						评价|设计     最近一段时间研究了一下bbs方面的一些程序,也拜读了本站bbs的源程序,自己觉得受益匪浅,很多程序都堪称典范.在主要的论坛贴子处理方面,很多的论坛也都模仿此作.因为我不想总拿别人的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9a9VM.html" rel="bookmark" class="title">在ASP应用中如何限制同一表单被多次提交</a>
					<div>
						在Internet上我们每天都会遇到数不清的表单,也看到其中大部分并没有限制用户多次提交同一个表单.缺乏这种限制有时候会产生某些预料不到的结果,如重复订阅邮件服务或重复投票等.    本文介绍在ASP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNPy1b.html" rel="bookmark" class="title">打造全方位的综合化接入网-UT斯达康FTTB&sol;FTTH应用解决方案</a>
					<div>
						GEPON技术成就先进接入方案 随着Internet用户数量的快速增长,IPTV业务以及各类网络互动业务的出现对承载网络带宽提出了越来越高的要求.光纤是最理想的高带宽承载媒介,随着光纤及相关器件成本的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW12rmz.html" rel="bookmark" class="title">Osoon点播系统</a>
					<div>
						1 简介 点播是指客户端与服务器之间的主动连接,在点播连接中,用户通过选择内容项目来初始化客户端连接.用户可以开始.停止.后退.快进或暂停流. 2 组成 2.1 OSProducer OS Produ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NEoNz.html" rel="bookmark" class="title">C语言函数大全&lpar;e开头&rpar;</a>
					<div>
						函数名: ecvt 功能: 把一个浮点数转换为字符串 用法: char ecvt(double value, int ndigit, int *decpt, int *sign); 程序例: #inc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOJALM.html" rel="bookmark" class="title">自定义java工具库</a>
					<div>
						掌握前述的知识后,接下来就可以开始创建自己的工具库,以便减少或者完全消除重复的代码.例如,可为System.out.println()创建一个别名,减少重复键入的代码量.它可以是名为tools的一个包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK8Orp.html" rel="bookmark" class="title">搜狗拼音输入法皮肤编辑器使用方法</a>
					<div>
						本教程为大家介绍一下搜狗拼音输入法皮肤编辑器使用方法,下面一起来看看具体方法吧. 搜狗输入法最新版本中集成了输入法编辑器,右键输入法状态栏或右键输入框→更换皮肤→皮肤编辑器,搜狗输入法官网也提供搜狗皮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myr7yvp.html" rel="bookmark" class="title">将字体嵌入PowerPoint文件随身携带</a>
					<div>
						我们经常会遇到这样的情况:由于每台计算机中安装的字体文件不同,在一台计算机上制作好的PowerPoint课件在另一台计算机上打开时,设定的字体会发生改变,影响课件的播放效果. 其实,只要在保存Powe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGV5wb.html" rel="bookmark" class="title">PS打造移轴镜头下的微观模型世界</a>
					<div>
						  移轴镜摄影(Tilt-shift photography)泛指利用移轴镜头创作的作品,所拍摄的照片效果就像是缩微模型一样,非常特别. 移轴镜头的作用,本来主要是用来修正以普通广角镜拍照时所产生出的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwXjkb.html" rel="bookmark" class="title">Excel2013 如何隐藏某行和列单元格</a>
					<div>
						  今天跟大家分享的是关于Excel2013中,如何隐藏某行和列单元格及取消隐藏单元格的方法.快来学习吧,学会了隐藏某行或某列单元格的话你就可以保护好自己的隐私了,例如一个会计可以很方便的隐藏大家工资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY5W2M.html" rel="bookmark" class="title">U盘量产故障的解决方法案例</a>
					<div>
						U盘可以量产成多种模式,许多朋友将U盘量产CD-ROM后发现一插入电脑,系统就会提示你重启,虽然选择不重启也可以正常使用,并且第二次插入同一 台电脑也不会再出现提示,但对于有强迫症的朋友来说一定会觉得 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq83dZb.html" rel="bookmark" class="title">小技巧把WinPE隐藏起来</a>
					<div>
						  WinPE大家应该不会陌生了,装系统的时候都要用到.但平时我们用到的winpe系统都是安装在U盘上的,其实WinPE也可以安装在硬盘上,并且还可以安装在硬盘的隐藏分区里,隐藏分区在Windows下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72DPAp.html" rel="bookmark" class="title">笔记本屏幕亮度无法调节了怎么办</a>
					<div>
						  进入系统后无法调节屏幕的亮度,遇见这种情况有两种可能,一是需要安装一个软件,在官方网站下载专区软件里找到热键驱动软件装完以后就可以正常使用组合键调节屏幕亮度了.二是显卡驱动没有装好,导致无法调节亮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQma8z.html" rel="bookmark" class="title">将数组元素按顺序放入链表中并进行插入删除等操作的编程问题</a>
					<div>
						问题描述 将数组元素按顺序放入链表中并进行插入删除等操作的编程问题 编译无错误,但是无法运行,感觉是将数组当做参数那个地方出了问题,但是不知道具体原因,求助CSDN的朋友帮忙解答,万分感谢 解决方案  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QQ0Ap.html" rel="bookmark" class="title">阿里云服务器怎么绑定域名？</a>
					<div>
						注意,请先到阿里云官网领取幸运券,除了价格上有很多优惠外,还可以参与抽奖.详见:https://promotion.aliyun.com/ntms/act/ambassador/sharetouser ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Ndwqz.html" rel="bookmark" class="title">java-eclipse怎样把JDK1&period;7的项目在JDK1&period;6中用啊？</a>
					<div>
						问题描述 eclipse怎样把JDK1.7的项目在JDK1.6中用啊? 在eclipse中导进去了一个JDK1.7的项目,有红叹号...怎么解决.我的eclipse是1.6 解决方案 首先,在项目名称 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdR092b.html" rel="bookmark" class="title">求一思路和实现方法</a>
					<div>
						问题描述 最近客户要做一个首页形象展示功能,要求用JS代码开发,有6个格子,2行排列,每个格子在鼠标没有滑过时候都是空白,当鼠标滑过任意一个格子,格子里面就开始淡入淡出显示五张图片,鼠标任意事件离开格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZGOap.html" rel="bookmark" class="title">&commat;JsonView 简单介绍</a>
					<div>
						@JsonView是jackson json中的一个注解,Spring webmvc也支持这个注解. 这个注解的作用就是控制输入输出后的json. 假设我们有一个用户类,其中包含用户名和密码,一般情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBVBGM.html" rel="bookmark" class="title">深入浅出Mybatis系列（四）---配置详解之typeAliases别名（mybatis源码篇）</a>
					<div>
						深入浅出Mybatis系列(四)---配置详解之typeAliases别名(mybatis源码篇) 上篇文章&lt;深入浅出Mybatis系列(三)---配置详解之properties与environ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1ra9z.html" rel="bookmark" class="title">&lpar;ORACLE&rpar;查看分区表的相关信息</a>
					<div>
						ORACLE数据库如何查看分区表的相关信息呢?不知道你有没有总结过这方面的知识.下面我们先创建两个表TEST. GPRS_CELLTOPVOL_WK来做实验,脚本如下: CREATE TABLE GP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKxo1b.html" rel="bookmark" class="title">去中心化时代，逆向社区O2O崛起</a>
					<div>
						12月11日,在微信公开课PRO版上,&quot;微信之父&quot;张小龙通过视频就微信公众号发表了演讲.张小龙主要提到了微信公众号生态设计与规划的&quot;八大点&quot;,尤其是微信生态系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40ZEYz.html" rel="bookmark" class="title">跨越科技鸿沟：摩根士丹利如何用机器学习辅助财富管理？</a>
					<div>
						本文作者之一是巴布森学院(Babson College)管理及信息通信系教授,麻省理工学院数字经济研究员Thomas H. Davenport,同时他还担任德勤高级顾问.另一作者Randy Bean  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60EWNz.html" rel="bookmark" class="title">sql server2005里导入bak文件</a>
					<div>
						  步骤一 右击SQL Server 2005实例下的&quot;数据库&quot;文件夹.就是与安全性.服务器对象同级的目录.选择新建数据库. 步骤二 添加数据库名称,名称与备份的数据库名称一致,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye0O4M.html" rel="bookmark" class="title">支付宝泄密事件引发波澜：百度联盟向360浏览器说不</a>
					<div>
						近日,支付宝泄密事件引起了社会各界对网络信息安全的再度关注.不少网友对支付宝的官方声明表示质疑,认为泄密背后的元凶是一直以来风波不断,被业内质疑存在安全隐患的360浏览器.受此影响,昨日百度联盟也加入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg5q4M.html" rel="bookmark" class="title">【新闻晨报】CES2014可穿戴式设备盘点   2014互联网金融降温</a>
					<div>
						中云网每天精选各科技媒体头条! 1. 凤凰科技 苹果中国开启&quot;红色星期五&quot;活动 产品最高降价700元 http://tech.ifeng.com/it/detail_2014_01 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
